/*======================================证件照制作高精版预览接口_免费======================================*/
package main

import (
	"bytes"
	"crypto/md5"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"log"
	"net/http"
)

func ImgtoBase64Preview(filePath string) string {
	//图片转Base64
	bytes, err := ioutil.ReadFile(filePath)
	if err != nil {
		log.Fatal(err)
	}
	var base64Encoding string
	base64Encoding += base64.StdEncoding.EncodeToString(bytes)
	return base64Encoding
}

func MD5Preview(v string) string {
	d := []byte(v)
	m := md5.New()
	m.Write(d)
	b := m.Sum(nil)
	return base64.StdEncoding.EncodeToString([]byte(b))
}

func main() {
	appCode := "你的appcode"
	PreviewUrl := "https://idphotohq-open.segapi.com/preview"

	client := &http.Client{}
	data := make(map[string]interface{})
	data["photo"] = ImgtoBase64Preview("1.jpg")
	data["spec"] = "1" //见证件照规格列表
	data["with_photo_key"] = 1 //图片photo_key，证件照制作接口返回的值， photo和photo_key设置一个即可，如果两个都设置，则使用photo参数"

	var bkList []string
	bkList = append(bkList, "white", "red", "#887799")
	data["bk_list"] = bkList // 需要制作的背景颜色列表，支持'blue', 'red', 'white', 'blue_gradual', 'red_gradual', 'white_gradual', 'blue_grey'等值，以及以#开头的6位16禁止颜色值，一次最多支持10颜色
	//data["beauty_degree"] = 1.5  // 可选参数，美颜级别，浮点型，取值[1.0-5.0]，超出范围后的值无效。主要调节了脸部黑白平衡。

	bytesData, _ := json.Marshal(data)
	req, _ := http.NewRequest("POST", PreviewUrl, bytes.NewReader(bytesData))
	req.Header.Set("Content-Type", "application/json")
	req.Header.Set("Authorization", "APPCODE "+appCode)

	md5Str := MD5Preview(string(bytesData))
	req.Header.Set("Content-MD5", md5Str)

	resp, _ := client.Do(req)
	fmt.Println(resp.Header)
	fmt.Println(resp.Header["X-Ca-Error-Message"])
	body, _ := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))

}
